<template>
  <div class="table-container">
    <vab-query-form>
      <div class="title">
        <div class="left">
          <div class="left-item">
            <div style="width: 100px;">风机名称：</div>
            <el-input v-model="fuzzyQuery_name" placeholder="请输入" clearable />
          </div>
          <el-button icon="el-icon-search" type="primary" native-type="submit" @click="handleQuery">
            查询
          </el-button>
        </div>
        <div class="right">
          <el-button icon="el-icon-plus" type="primary" @click="handleAdd">
            添加
          </el-button>
          <el-button icon="el-icon-delete" type="danger" @click="handleDelete">
            删除
          </el-button>
          <UploadExcel style="margin-left: 10px;" @getResult="getMyExcelData"></UploadExcel>
          <ExportExcel :exportList="exportExcel" :useType="'export'" partsName="风机"></ExportExcel>
          <ExportExcel :exportList="templateExcel" :useType="'template'" partsName="风机模板"></ExportExcel>
        </div>
      </div>
      <el-table ref="tableSort" v-loading="listLoading" :data="list" :element-loading-text="elementLoadingText"
        header-cell-class-name="table_header_style" border
        :height="height" @selection-change="setSelectRows">
        <el-table-column show-overflow-tooltip type="selection" width="55" align="center"></el-table-column>
        <el-table-column show-overflow-tooltip label="编码" prop="id" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="编号" prop="status" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="风机名称" prop="name" align="center" sortable></el-table-column>
        <el-table-column width="150" show-overflow-tooltip label="首次并网时间" prop="firstintegratedtime" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="风场编号" prop="windpowerstationid" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="工程编号" prop="projectid" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="线路编号" prop="lineid" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="地球纬度" prop="latitude" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="地球经度" prop="longitude" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="机型" prop="modelid" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="图片" prop="photo" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="标杆风机" prop="standardid" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="操作" fixed="right">
          <template #default="{ row }">
            <el-button type="text" @click="handleEdit(row)">编辑</el-button>
            <el-button type="text" @click="handleDelete(row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination :background="background" :current-page="queryForm.pageNo" :layout="layout"
        :page-size="queryForm.pageSize" :total="total" @current-change="handleCurrentChange"
        @size-change="handleSizeChange"></el-pagination>
      <table-edit ref="edit" :options="options" :stationList="stationList" @save-success="fetchData"></table-edit>
    </vab-query-form>
  </div>
</template>
<script>
import UploadExcel from '@/components/UploadExcel/index'
import ExportExcel from '@/components/ExportExcel/index'
import api from '@/api/station'
import TableEdit from './components/TableEdit'
import { recursionTree } from '@/utils/deepTree'
export default {
  components: {
    UploadExcel,
    ExportExcel,
    TableEdit,
  },
  data() {
    return {
      fuzzyQuery_name: '',
      listLoading: true,
      list: [],
      options: [],
      exportExcel: [],
      templateExcel: [],
      elementLoadingText: '正在加载...',
      selectRows: '',
      layout: 'total, sizes, prev, pager, next, jumper',
      total: 0,
      background: true,
      exportList: [],
      queryForm: {
        pageNo: 1,
        pageSize: 20,
      },
      stationList: [],
      selectValue: ''
    };
  },
  computed: {
    height() {
      return this.$baseTableHeight() + 50
    },
  },
  created() {
    this.getStation()
    this.fetchData()
    this.getTree()
  },
  methods: {
    handleQuery() {
      this.queryForm.pageNo = 1
      this.fetchData()
    },
    nameEcho(row){
      let arr = row.windpowerstationid.split(",")
      let str = ""
      if(this.deepTreeData) {
        this.deepTreeData.forEach(element => {
          if(arr[arr.length -1] == element.id){
            str = element.name
          }
        });
      }
      return str
    },
    getTree() {
      api.newtreeTreels({tag:4}).then(res => {
        if (res.data) {
          this.options = res.data
          this.deepTreeData = recursionTree(res.data)
        }
      })
    },
    getMyExcelData(val) {
      val.forEach(item => {
        api.addWindturbine(item).then(res => {
          if (res.code == 200) {
            this.$message({
              type: 'success',
              message: '添加成功!'
            });
            this.fetchData()
          }
        })
      })
    },
    getStation() {
      api.windpowerstationList({
        id: '',
        name: '',
        companyid: '',
        pageNum: 1,
        pageSize: 1000,
      }).then(res => {
        if (res.data) {
          this.listLoading = false
          this.stationList = res.data.records
        }
      })
    },
    fetchData() {
      api.windturbine({
        name: this.fuzzyQuery_name,
        pageNum: this.queryForm.pageNo,
        pageSize: this.queryForm.pageSize,
      }).then(res => {
        if (res.data) {
          this.listLoading = false
          this.total = res.data.total
          this.list = res.data.records
          this.templateExcel = [
            {
              id: '',
              status: '',
              name: '',
              firstintegratedtime: '',
              windpowerstationid: '',
              projectid: '',
              lineid: '',
              latitude: '',
              longitude: '',
              modelid: '',
              photo: '',
              standardid: '',
            }
          ]
          // 导出
          let exportExcel = []
          res.data.records.forEach(item => {
            exportExcel.push({
              id: item.id,
              status: item.status,
              name: item.name,
              firstintegratedtime: item.firstintegratedtime,
              windpowerstationid: item.windpowerstationid,
              projectid: item.projectid,
              lineid: item.lineid,
              latitude: item.latitude,
              longitude: item.longitude,
              modelid: item.modelid,
              photo: item.photo,
              standardid: item.standardid,
            })
          })
          this.exportExcel = exportExcel
        }
      })
    },
    handleSizeChange(val) {
      this.queryForm.pageSize = val
      this.fetchData()
    },
    handleCurrentChange(val) {
      this.queryForm.pageNo = val
      this.fetchData()
    },
    handleAdd() {
      this.$refs['edit'].showEdit()
    },
    handleEdit(row) {
      this.$refs['edit'].showEdit(row)
    },
    handleDelete(row) {
      if (row.id || this.selectRows.length > 0) {
        this.$baseConfirm('你确定要删除吗', null, async () => {
          let ids = ''
          if (this.selectRows.length > 0) {
            ids = this.selectRows.map((item) => item.id).join()
          }
          api.deleteWindturbine({
            id: row.id || ids
          }).then(res => {
            if (res.data) {
              this.$baseMessage('删除成功', 'success')
              this.fetchData()
            }
          })
        })
      } else {
        this.$baseMessage('未选中任何行', 'error')
        return false
      }
    },
    setSelectRows(val) {
      this.selectRows = val
    },
  },
}
</script>
<style lang="less" scoped>
.title {
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 20px;
}

.left {
  display: flex;
  flex-direction: row;
  align-items: center;

  .left-item {
    display: flex;
    flex-direction: row;
    align-items: center;
    margin-right: 10px;
  }
}
</style>